{ $Id: PDOMessages.pas 52 2007-01-30 00:10:24Z jmarino $

############################################################################################

	Pascal Data Objects Library
	Copyright  2006 John Marino, http://www.synsport.com
	Project site: http://pdo.sourceforge.net

	Note: This file contains code fragments from Zeoslib
	Copyright  1999-2004 Sergey Seroukhov

############################################################################################

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

############################################################################################}



unit PDOMessages;

interface

{$I directives.inc}

resourcestring

{$IFDEF PORTUGUESE}

  SDriverWasNotFound = 'O driver de banco/Protocolo de dados requisitado no foi encontrado';
  SUnsupportedOperation = 'Operao no suportado';
  SLibraryNotFound = 'Nenhuma biblioteca dinamica da lista %s foi encontrada';
  SUnsupportedDataType = 'Tipo de dado no suportado';
  SUnsupportedParameterType = 'Tipo de parmetro no suportado';
  SBoundVarStrIndexMissing = 'Translate: Bound variable text index "%s" does not exist';
  SBindingFailure = 'Translate: Failed to bind parameter set';
  SPreparedStmtExecFailure = 'Translate: Prepared statement failed to execute';
  SFailedToBindAllColumns = 'Translate: Application failed to pre-bind all columns';
  SFailedToBindResults    = 'Translate: Application failed to bind to the result set';
  SFailedToBindAllValues  = 'Translate: Application failed to pre-bind all values';
  SFailedtoInitPrepStmt   = 'Translate: Prepared statement failed to initialize';
  SFailedtoPrepareStmt    = 'Translate: Statement failed during prepare process';
  SFailedFetchingResult   = 'Translate: Statement failed to return bound results.';
  SBindVarOutOfRange      = 'Translate: Bound variable index out of range: %d';
  SBindColumnOutOfRange   = 'Translate: Bound Column index out of range: %d';
  SAttemptExecOnBadPrep   = 'Translate: Attempt made to execute a statement before a successful preparation.';
  SUsedWrongExecute       = 'Translate: This version of execute only works with prepared statements.';
  SUnsupportedByDriver    = 'Translate: Driver can not support this feature natively: [%s]';
  SLastQueryFailed        = 'Translate: The last query failed, so subsequent fetch request is ignored';
  SDSNMissingEqual        = 'Translate: BAD DSN: The provided DSN has no "=" character in it';
  SNoConnection           = 'Translate: No connection present';
  SQueryWithOutConnect    = 'Translate: Attempted query without connection';
  SRollbackFailed         = 'Translate: Rollback failed!';
  SRollbackSuccessful     = 'Translate: Rollback succeeded';
  SQueryFailed            = 'Translate: Failed: %s';
  SQuerySuccessful        = 'Translate: Success: %s';
  SNeedOrderBy            = 'Translate: SQL dialect requires assembled queries must use the ORDER BY parameter';
  SEstablishDialect       = 'Translate: The SQL dialect must be established by connecting to DB before statement construction';
  SSQLAssemblyError       = 'Translate: SQL statement construction error';
  SBeginTransaction       = 'Translate: Explicit transaction started';
  BEndTransaction         = 'Translate: Explicit transaction ended';
  SStatementIsNotAllowed  = 'Translate: This sql is not allowed now: %s';
  SInvalidState           = 'Estado invlido';
  SErrorConvertion        = 'Erro de converso';
  SErrorConvertionField   = 'Erro de converso para do campo "%s" para SQLType "%s"';
{$ELSE}

{$IFDEF DUTCH}

  SDriverWasNotFound = 'Gevraagde database driver/protocol is niet gevonden';
  SUnsupportedOperation = 'Niet ondersteunde operatie';
  SLibraryNotFound = 'DLL van de lijst %s werd niet gevonden';
  SUnsupportedDataType = 'Niet ondersteund data type';
  SUnsupportedParameterType = 'Niet ondersteund parameter type';
  SBoundVarStrIndexMissing = 'Translate: Bound variable text index "%s" does not exist';
  SBindingFailure = 'Translate: Failed to bind parameter set';
  SPreparedStmtExecFailure = 'Translate: Prepared statement failed to execute';
  SFailedToBindAllColumns = 'Translate: Application failed to pre-bind all columns';
  SFailedToBindResults    = 'Translate: Application failed to bind to the result set';
  SFailedToBindAllValues  = 'Translate: Application failed to pre-bind all values';
  SFailedtoInitPrepStmt   = 'Translate: Prepared statement failed to initialize';
  SFailedtoPrepareStmt    = 'Translate: Statement failed during prepare process';
  SFailedFetchingResult   = 'Translate: Statement failed to return bound results.';
  SBindVarOutOfRange      = 'Translate: Bound variable index out of range: %d';
  SBindColumnOutOfRange   = 'Translate: Bound Column index out of range: %d';
  SAttemptExecOnBadPrep   = 'Translate: Attempt made to execute a statement before a successful preparation.';
  SUsedWrongExecute       = 'Translate: This version of execute only works with prepared statements.';
  SUnsupportedByDriver    = 'Translate: Driver can not support this feature natively: [%s]';
  SLastQueryFailed        = 'Translate: The last query failed, so subsequent fetch request is ignored';
  SDSNMissingEqual        = 'Translate: BAD DSN: The provided DSN has no "=" character in it';
  SNoConnection           = 'Translate: No connection present';
  SQueryWithOutConnect    = 'Translate: Attempted query without connection';
  SRollbackFailed         = 'Translate: Rollback failed!';
  SRollbackSuccessful     = 'Translate: Rollback succeeded';
  SQueryFailed            = 'Translate: Failed: %s';
  SQuerySuccessful        = 'Translate: Success: %s';
  SNeedOrderBy            = 'Translate: SQL dialect requires assembled queries must use the ORDER BY parameter';
  SEstablishDialect       = 'Translate: The SQL dialect must be established by connecting to DB before statement construction';
  SSQLAssemblyError       = 'Translate: SQL statement construction error';
  SBeginTransaction       = 'Translate: Explicit transaction started';
  BEndTransaction         = 'Translate: Explicit transaction ended';
  SStatementIsNotAllowed  = 'Translate: This sql is not allowed now: %s';
  SInvalidState           = 'Ongeldige status';
  SErrorConvertion        = 'Conversiefout';
  SErrorConvertionField   = 'Conversie fout voor veld "%s" naar SQLType "%s"';
{$ELSE}

{$IFDEF GERMAN}

  SDriverWasNotFound = 'Der angegebene Datenbanktreiber/Protokoll wurde nicht gefunden';
  SUnsupportedOperation = 'Nicht untersttzte Operation';
  SLibraryNotFound = 'Es wurde keine der in %s gelisteten DLL''s gefunden';
  SUnsupportedDataType = 'Der Datentyp wird nicht untersttzt';
  SUnsupportedParameterType = 'Der Parametertyp wird nicht untersttzt';
  SBoundVarStrIndexMissing = 'Translate: Bound variable text index "%s" does not exist';
  SBindingFailure = 'Translate: Failed to bind parameter set';
  SPreparedStmtExecFailure = 'Translate: Prepared statement failed to execute';
  SFailedToBindAllColumns = 'Translate: Application failed to pre-bind all columns';
  SFailedToBindResults    = 'Translate: Application failed to bind to the result set'  SFailedToBindAllValues  = 'Translate: Application failed to pre-bind all values';
  SFailedtoInitPrepStmt   = 'Translate: Prepared statement failed to initialize';
  SFailedtoPrepareStmt    = 'Translate: Statement failed during prepare process';
  SFailedFetchingResult   = 'Translate: Statement failed to return bound results.';
  SBindVarOutOfRange      = 'Translate: Bound variable index out of range: %s';
  SBindColumnOutOfRange   = 'Translate: Bound Column index out of range: %d';
  SAttemptExecOnBadPrep   = 'Translate: Attempt made to execute a statement before a successful preparation.';
  SUsedWrongExecute       = 'Translate: This version of execute only works with prepared statements.';
  SUnsupportedByDriver    = 'Translate: Driver can not support this feature natively: [%s]';
  SLastQueryFailed        = 'Translate: The last query failed, so subsequent fetch request is ignored';
  SDSNMissingEqual        = 'Translate: BAD DSN: The provided DSN has no "=" character in it';
  SNoConnection           = 'Translate: No connection present';
  SQueryWithOutConnect    = 'Translate: Attempted query without connection';
  SRollbackFailed         = 'Translate: Rollback failed!';
  SRollbackSuccessful     = 'Translate: Rollback succeeded';
  SQueryFailed            = 'Translate: Failed: %s';
  SQuerySuccessful        = 'Translate: Success: %s';
  SNeedOrderBy            = 'Translate: SQL dialect requires assembled queries must use the ORDER BY parameter';
  SEstablishDialect       = 'Translate: The SQL dialect must be established by connecting to DB before statement construction';
  SSQLAssemblyError       = 'Translate: SQL statement construction error';
  SBeginTransaction       = 'Translate: Explicit transaction started';
  BEndTransaction         = 'Translate: Explicit transaction ended';
  SStatementIsNotAllowed  = 'Translate: This sql is not allowed now: %s';
  SInvalidState           = 'Ungltiger Status';
  SErrorConvertion        = 'Konvertierungsfehler';
  SErrorConvertionField   = 'Konvertierungsfehler bei Feld "%s" nach SQL-Typ "%s"';
{$ELSE}

{$IFDEF SPANISH} //Spanish translations

  SDriverWasNotFound = 'No se encontr el controlador de base o protocolo de datos solicitado';
  SUnsupportedOperation = 'Operacin no soportada';
  SLibraryNotFound = 'Ninguna librera dinmica de la lista %s fue encontrada';
  SUnsupportedDataType = 'Tipo de datos no soportado';
  SUnsupportedParameterType = 'Tipo de parmetro no soportado';
  SBoundVarStrIndexMissing = 'Translate: Bound variable text index "%s" does not exist';
  SBindingFailure = 'Translate: Failed to bind parameter set';
  SPreparedStmtExecFailure = 'Translate: Prepared statement failed to execute';
  SFailedToBindAllColumns = 'Translate: Application failed to pre-bind all columns';
  SFailedToBindResults    = 'Translate: Application failed to bind to the result set';
  SFailedToBindAllValues  = 'Translate: Application failed to pre-bind all values';
  SFailedtoInitPrepStmt   = 'Translate: Prepared statement failed to initialize';
  SFailedtoPrepareStmt    = 'Translate: Statement failed during prepare process';
  SFailedFetchingResult   = 'Translate: Statement failed to return bound results.';
  SBindVarOutOfRange      = 'Translate: Bound variable index out of range: %d';
  SBindColumnOutOfRange   = 'Translate: Bound Column index out of range: %d';
  SAttemptExecOnBadPrep   = 'Translate: Attempt made to execute a statement before a successful preparation.';
  SUsedWrongExecute       = 'Translate: This version of execute only works with prepared statements.';
  SUnsupportedByDriver    = 'Translate: Driver can not support this feature natively: [%s]';
  SLastQueryFailed        = 'Translate: The last query failed, so subsequent fetch request is ignored';
  SDSNMissingEqual        = 'La DSN no contiene una "=" carcter';
  SNoConnection           = 'No hay conexin';
  SQueryWithOutConnect    = 'Esta es consulta sin conexin';
  SRollbackFailed         = 'Rollback fallado!';
  SRollbackSuccessful     = 'Rollback logrado';
  SQueryFailed            = 'Fallado: %s';
  SQuerySuccessful        = 'Logrado: %s';
  SNeedOrderBy            = 'Translate: SQL dialect requires assembled queries must use the ORDER BY parameter';
  SEstablishDialect       = 'Translate: The SQL dialect must be established by connecting to DB before statement construction';
  SSQLAssemblyError       = 'Translate: SQL statement construction error';
  SBeginTransaction       = 'Translate: Explicit transaction started';
  BEndTransaction         = 'Translate: Explicit transaction ended';
  SStatementIsNotAllowed  = 'Translate: This sql is not allowed now: %s';
  SInvalidState           = 'Estado Invlido';
  SErrorConvertion        = 'Error de conversin';
  SErrorConvertionField   = 'Error de conversin de la columna "%s" al tipo SQL "%s"';

{$ELSE} // default: ENGLISH

  SDriverWasNotFound = 'Requested database driver or protocol was not found';
  SUnsupportedOperation = 'Unsupported operation';
  SLibraryNotFound = 'None of the dynamic libraries can be found: %s';
  SUnsupportedDataType = 'Unsupported data type';
  SUnsupportedParameterType = 'Unsupported parameter type';
  SBoundVarStrIndexMissing = 'Bound variable text index "%s" does not exist';
  SBindingFailure = 'Failed to bind parameter set';
  SPreparedStmtExecFailure = 'Prepared statement failed to execute';
  SFailedToBindAllColumns = 'Application failed to pre-bind all columns';
  SFailedToBindAllValues  = 'Application failed to pre-bind all values';
  sFailedToBindResults    = 'Application failed to bind to the result set';
  SFailedtoInitPrepStmt   = 'Prepared statement failed to initialize';
  SFailedtoPrepareStmt    = 'Statement failed during prepare process';
  SFailedFetchingResult   = 'Statement failed to return bound results.';
  SBindVarOutOfRange      = 'Bound variable index out of range: %d';
  SBindColumnOutOfRange   = 'Bound Column index out of range: %d';
  SAttemptExecOnBadPrep   = 'Attempt made to execute a statement before a successful preparation.';
  SUsedWrongExecute       = 'This version of execute only works with prepared statements.';
  SUnsupportedByDriver    = 'Driver can not support this feature natively: [%s]';
  SLastQueryFailed        = 'The last query failed, so subsequent fetch request is ignored';
  SDSNMissingEqual        = 'The provided DSN has no "=" character in it';
  SNoConnection           = 'No connection present';
  SQueryWithOutConnect    = 'Attempted query without connection';
  SRollbackFailed         = 'Rollback failed!';
  SRollbackSuccessful     = 'Rollback succeeded';
  SQueryFailed            = 'Failed: %s';
  SQuerySuccessful        = 'Success: %s';
  SNeedOrderBy            = 'SQL dialect requires assembled queries must use the ORDER BY parameter';
  SEstablishDialect       = 'The SQL dialect must be established by connecting to DB before statement construction';
  SSQLAssemblyError       = 'SQL statement construction error';
  SBeginTransaction       = 'Explicit transaction started';
  BEndTransaction         = 'Explicit transaction ended';
  SStatementIsNotAllowed  = 'This sql is not allowed now: %s';
  SInvalidState           = 'Invalid state';
  SErrorConvertion        = 'Convertion error';
  SErrorConvertionField   = 'Conversion error for field "%s" to SQLType "%s"';

{$ENDIF} // SPANISH
{$ENDIF} // GERMAN
{$ENDIF} // DUTCH
{$ENDIF} // PORTUGUESE

implementation

end.
