{ $Id: directives.inc 52 2007-01-30 00:10:24Z jmarino $ }

{*********************************************************}

{$IFDEF FPC}
	{$mode delphi}
{$ENDIF}

{$IFDEF FREEBSD}
	{$DEFINE UNIX}
{$ENDIF}

{$IFDEF LINUX}
	{$DEFINE UNIX}
{$ENDIF}

// Debug/release compiler options

{$IFOPT D-}
	{$DEFINE BINARY_RELEASE}
{$ENDIF}

{$IFDEF BINARY_RELEASE}

// Settings for Release mode
	{$C-}
	{$I-}
	{$R-}
	{$L-}
	{$Q-}
	{$IFNDEF FPC}
		{$O+}
		{$W-}
	{$ENDIF}

{$ELSE}

// Settings for Debug mode
	{$C+}
	{$I+}
	{$L+}
	{$Q+}
	{$IFNDEF FPC}
		{$O-}
		{$W+}
		{$R+}
	{$ENDIF}

{$ENDIF}


// Supported language. Now available languages:
// ENGLISH, GERMAN, PORTUGUESE, DUTCH, SPANISH
{$DEFINE ENGLISH}

// Enables MySQL support
{$DEFINE ENABLE_MYSQL}
{$IFDEF ENABLE_MYSQL}
    {$DEFINE MYSQL40DRIVER}
    {$DEFINE MYSQL41DRIVER}
    {$DEFINE MYSQL50DRIVER}
{$ENDIF}

// Enables Interbase/Firebird support
{$DEFINE ENABLE_FIREBIRD}
{$IFDEF ENABLE_FIREBIRD}
    {Classic / Superserver versions}
    {$DEFINE FIREBIRD20DRIVER}
    {$DEFINE FIREBIRD15DRIVER}

    {Embedded versions}
    {$DEFINE FIREBIRD20EMBDRIVER}
    {$DEFINE FIREBIRD15EMBDRIVER}
{$ENDIF}


// Enables PostgreSQL support
//{$DEFINE ENABLE_POSTGRESQL}

// Enables Sybase/MSSQL support
//{$DEFINE ENABLE_DBLIB}




// Enables SQLite support in
//{$DEFINE ENABLE_SQLITE}

// Enables Oracle support
//{$DEFINE ENABLE_ORACLE}

// Enables DB2/ODBC support
//{$DEFINE ENABLE_DB2}

// Prevents loading default libmysql.dll
//{$DEFINE MYSQL_STRICT_DLL_LOADING}

// Prevents loading default libpq.dll
//{$DEFINE POSTGRESQL_STRICT_DLL_LOADING}

// Prevents loading default firebird.dll 
//{$DEFINE FIREBIRD_STRICT_DLL_LOADING}

//Allows to see SQL exceptions as strings 
//{$DEFINE INTERBASE_EXTENDED_MESSAGES}

// Loads libcrypt.so before Firebird client library.
// It fixes error "Undefined symbol: crypt".
//{$DEFINE INTERBASE_CRYPT}

// Turn on multithreading
{$DEFINE MULTI_THREADED}

// Use libfbclient.so under linux
// and not libfbembed.so when Firebird 1.5.2 is used under linux
{$DEFINE USELIBFBCLIENTSO}



// Compilation directives for Delphi 5
// 130 = delphi 4, 140 = delphi 5
//Deleting hacks for Delphi 4, can't test it at all
//Currently no functionality switches on delphi 5 either
//
//{$IFDEF VER130}
//	{$DEFINE VER130BELOW}
//	{$DEFINE VER140BELOW}
//{$ENDIF}
//
//{$IFDEF VER140}
//	{$DEFINE VER140BELOW}
//{$ENDIF}


// Disables checking code.
// Use Range checking option to turn on/off optimization
//{$IFOPT R-}
//	{$DEFINE DISABLE_CHECKING}
//{$ENDIF}
