{ $Id: PDOResultFirebird.pas 52 2007-01-30 00:10:24Z jmarino $

############################################################################################

	Pascal Data Objects Library
	Copyright  2006 John Marino, http://www.synsport.com
	Project site: http://pdo.sourceforge.net

############################################################################################

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

############################################################################################}

unit PDOResultFirebird;

interface

{$I ../../directives.inc}

uses PDOStatement, Classes, PDOCompatibility, SysUtils,
     PDOSysUtils, PDOInterfaces, PDOResult;

type
    TFirebirdResult = class (TResult)
        private
            RawTime: TDateTime;
        public
            function asDate:          TDateTime; override;
            function asTime:          TDateTime; override;
            function asTimestamp:     TDateTime; override;
            constructor create(nativeType: TZSQLType; stringRep: Ansistring;
                nullValue: Boolean; Timestamp: TDateTime);
        end;

implementation

constructor TFirebirdResult.create(
            nativeType: TZSQLType;
            stringRep: Ansistring;
            nullValue: Boolean;
            Timestamp: TDateTime);
begin
    self.RawTime := Timestamp;

    inherited create (nativeType, stringRep, nullValue);
end;

function TFirebirdResult.asTimestamp: TDateTime;
Begin
    Result := self.RawTime;
End;

function TFirebirdResult.asTime: TDateTime;
Begin
    Result := frac (self.RawTime);
End;

function TFirebirdResult.asDate: TDateTime;
Begin
    Result := trunc (self.RawTime);
End;


end.
