{ $Id: PDODriverFirebird15.pas 52 2007-01-30 00:10:24Z jmarino $

############################################################################################

	Pascal Data Objects Library
	Copyright  2006 John Marino, http://www.synsport.com
	Project site: http://pdo.sourceforge.net

	Note: This file contains code fragments from Zeoslib
	Copyright  1999-2004 Sergey Seroukhov

############################################################################################

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

############################################################################################}



unit PDODriverFirebird15;

interface

{$I ../../../directives.inc}

uses
	SysUtils, PDOClasses, PDOInterfaces, PDOConstantsFirebird, PDOLibraryFirebird15,
    PDOFirebirdDriver, PDOUtilsFirebird;

type
    TVersionPointers = array [0..9] of pointer;

  TFirebird15Driver = class (TFirebirdBaseDriver, IPDOProtocol)
  public
    function GetServerVersion (Handle: TISC_DB_HANDLE): AnsiString; override;
    function GetServerInfo    (Handle: TISC_DB_HANDLE): AnsiString; override;

    function GetProtocol: AnsiString; override;
    function GetDescription: AnsiString; override;
    procedure Initialize; override;
    function Get_Information (Handle: TISC_DB_HANDLE; item: TDatabaseInformation): ansistring;

    function isc_attach_database (status_vector: PISC_STATUS;
      db_name_length: Short; db_name: PChar; db_handle: PISC_DB_HANDLE;
      parm_buffer_length: Short; parm_buffer: PChar): ISC_STATUS; override;
    function isc_detach_database(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE): ISC_STATUS;  override;
    function isc_drop_database(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE): ISC_STATUS;  override;
    function isc_database_info(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; item_list_buffer_length: Short;
      item_list_buffer: PChar; result_buffer_length: Short;
      result_buffer: PChar): ISC_STATUS; override;
    function isc_array_gen_sdl(status_vector: PISC_STATUS;
      isc_array_desc: PISC_ARRAY_DESC; isc_arg3: PShort;
      isc_arg4: PChar; isc_arg5: PShort): ISC_STATUS; override;
    function isc_array_get_slice(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; trans_handle: PISC_TR_HANDLE;
      array_id: PISC_QUAD; descriptor: PISC_ARRAY_DESC;
      dest_array: PVoid; slice_length: ISC_LONG): ISC_STATUS; override;
    function isc_array_lookup_bounds(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; trans_handle: PISC_TR_HANDLE;
      table_name, column_name: PChar;
      descriptor: PISC_ARRAY_DESC): ISC_STATUS; override;
    function isc_array_lookup_desc(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; trans_handle: PISC_TR_HANDLE;
      table_name, column_name: PChar;
      descriptor: PISC_ARRAY_DESC): ISC_STATUS;  override;
    function isc_array_set_desc(status_vector: PISC_STATUS;
      table_name: PChar; column_name: PChar;
      sql_dtype, sql_length, sql_dimensions: PShort;
      descriptor: PISC_ARRAY_DESC): ISC_STATUS;  override;
    function isc_array_put_slice(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; trans_handle: PISC_TR_HANDLE;
      array_id: PISC_QUAD; descriptor: PISC_ARRAY_DESC;
      source_array: PVoid; slice_length: PISC_LONG): ISC_STATUS; override;
    function isc_free(isc_arg1: PChar): ISC_LONG; override;
    function isc_sqlcode(status_vector: PISC_STATUS): ISC_LONG;  override;
    procedure isc_sql_interprete(sqlcode: Short; buffer: PChar;
      buffer_length: Short); override;
    function isc_interprete(buffer: PChar; status_vector: PPISC_STATUS): ISC_STATUS; override;
    function isc_start_transaction(status_vector: PISC_STATUS;
      tran_handle: PISC_TR_HANDLE; db_handle_count: Short;
      db_handle: PISC_DB_HANDLE; tpb_length: Word; tpb_address: PChar): ISC_STATUS; override;
    function isc_start_multiple(status_vector: PISC_STATUS;
      tran_handle: PISC_TR_HANDLE; db_handle_count: Short;
      teb_vector_address: PISC_TEB): ISC_STATUS; override;
    function isc_rollback_transaction(status_vector: PISC_STATUS;
      tran_handle: PISC_TR_HANDLE): ISC_STATUS; override;
    function isc_rollback_retaining(status_vector: PISC_STATUS;
      tran_handle: PISC_TR_HANDLE): ISC_STATUS; override;
    function isc_commit_retaining(status_vector: PISC_STATUS;
      tran_handle: PISC_TR_HANDLE): ISC_STATUS; override;
    function isc_commit_transaction(status_vector: PISC_STATUS;
      tran_handle: PISC_TR_HANDLE): ISC_STATUS;  override;
    function isc_dsql_allocate_statement(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; stmt_handle: PISC_STMT_HANDLE): ISC_STATUS; override;
    function isc_dsql_alloc_statement2(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; stmt_handle: PISC_STMT_HANDLE): ISC_STATUS; override;
    function isc_dsql_describe(status_vector: PISC_STATUS;
      stmt_handle: PISC_STMT_HANDLE; dialect: Word; xsqlda: PXSQLDA): ISC_STATUS; override;
    function isc_dsql_describe_bind(status_vector: PISC_STATUS;
      stmt_handle: PISC_STMT_HANDLE; dialect: Word; xsqlda: PXSQLDA): ISC_STATUS; override;
    function isc_dsql_execute(status_vector: PISC_STATUS;
      tran_handle: PISC_TR_HANDLE; stmt_handle: PISC_STMT_HANDLE; dialect: Word;
      xsqlda: PXSQLDA): ISC_STATUS; override;
    function isc_dsql_execute2(status_vector: PISC_STATUS;
      tran_handle: PISC_TR_HANDLE; stmt_handle: PISC_STMT_HANDLE; dialect: Word;
      in_xsqlda, out_xsqlda: PXSQLDA): ISC_STATUS; override;
    function isc_dsql_execute_immediate(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; tran_handle: PISC_TR_HANDLE; length: Word;
      statement: PChar; dialect: Word; xsqlda: PXSQLDA): ISC_STATUS; override;
    function isc_dsql_fetch(status_vector: PISC_STATUS;
      stmt_handle: PISC_STMT_HANDLE; dialect: Word; xsqlda: PXSQLDA): ISC_STATUS; override;
    function isc_dsql_free_statement(status_vector: PISC_STATUS;
      stmt_handle: PISC_STMT_HANDLE; options: Word): ISC_STATUS; override;
    function isc_dsql_prepare(status_vector: PISC_STATUS;
      tran_handle: PISC_TR_HANDLE; stmt_handle: PISC_STMT_HANDLE;
      length: Word; statement: PChar; dialect: Word; xsqlda: PXSQLDA): ISC_STATUS; override;
    function isc_dsql_set_cursor_name(status_vector: PISC_STATUS;
      stmt_handle: PISC_STMT_HANDLE; cursor_name: PChar; _type: Word): ISC_STATUS; override;
    function isc_dsql_sql_info(status_vector: PISC_STATUS;
      stmt_handle: PISC_STMT_HANDLE; item_length: Short; items: PChar;
      buffer_length: Short; buffer: PChar): ISC_STATUS; override;
    function isc_open_blob2(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; tran_handle: PISC_TR_HANDLE;
      blob_handle: PISC_BLOB_HANDLE; blob_id: PISC_QUAD; bpb_length: Short;
      bpb_buffer: PChar): ISC_STATUS; override;
    function isc_create_blob2(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; tran_handle: PISC_TR_HANDLE;
      blob_handle: PISC_BLOB_HANDLE; blob_id: PISC_QUAD; bpb_length: Short;
      bpb_address: PChar): ISC_STATUS; override;
    function isc_blob_info(status_vector: PISC_STATUS;
      blob_handle: PISC_BLOB_HANDLE; item_list_buffer_length: Short;
      item_list_buffer: PChar; result_buffer_length: Short; result_buffer: PChar): PISC_STATUS; override;
    function isc_close_blob(status_vector: PISC_STATUS;
      blob_handle: PISC_BLOB_HANDLE): ISC_STATUS; override;
    function isc_cancel_blob(status_vector: PISC_STATUS;
      blob_handle: PISC_BLOB_HANDLE): ISC_STATUS; override;
    function isc_get_segment(status_vector: PISC_STATUS;
      blob_handle: PISC_BLOB_HANDLE; actual_seg_length: PWord;
      seg_buffer_length: Word; seg_buffer: PChar): ISC_STATUS; override;
    function isc_put_segment(status_vector: PISC_STATUS;
      blob_handle: PISC_BLOB_HANDLE; seg_buffer_len: Word; seg_buffer: PChar): ISC_STATUS; override;
    function isc_event_block(event_buffer: PPChar; result_buffer: PPChar;
      id_count: Word; event_list: array of PChar): ISC_LONG; override;
    procedure isc_event_counts(status_vector: PISC_STATUS;
      buffer_length: Short; event_buffer: PChar; result_buffer: PChar); override;
    function isc_cancel_events(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; event_id: PISC_LONG): ISC_STATUS; override;
    function isc_que_events(status_vector: PISC_STATUS;
      db_handle: PISC_DB_HANDLE; event_id: PISC_LONG; length: Short;
      event_buffer: PChar; event_function: TISC_CALLBACK;
      event_function_arg: PVoid): ISC_STATUS; override;
    procedure isc_decode_date(ib_date: PISC_QUAD; tm_date: PCTimeStructure); override;
    procedure isc_encode_date(tm_date: PCTimeStructure; ib_date: PISC_QUAD); override;
    { Interbase Version 6 routines }
    procedure isc_decode_sql_date(ib_date: PISC_DATE; tm_date: PCTimeStructure); override;
    procedure isc_decode_sql_time(ib_time: PISC_TIME; tm_date: PCTimeStructure); override;
    procedure isc_decode_timestamp(ib_timestamp: PISC_TIMESTAMP;
      tm_date: PCTimeStructure); override;
    procedure isc_encode_sql_date(tm_date: PCTimeStructure;
      ib_date: PISC_DATE); override;
    procedure isc_encode_sql_time(tm_date: PCTimeStructure;
      ib_time: PISC_TIME); override;
    procedure isc_encode_timestamp(tm_date: PCTimeStructure;
      ib_timestamp: PISC_TIMESTAMP); override;
    function isc_vax_integer(buffer: PChar; length: Short): ISC_LONG; override;
  end;

  TFirebird15EmbeddedDriver = class (TFirebird15Driver, IPDOProtocol)
  public
    function GetProtocol: AnsiString; override;
    function GetDescription: AnsiString; override;
    procedure Initialize; override;

  end;

   procedure version_callback (user_arg: PVoid; information: PChar); cdecl;


implementation

{Embedded Driver}

function TFirebird15EmbeddedDriver.GetProtocol: AnsiString;
begin
  Result := 'firebird-1.5E';
end;

function TFirebird15EmbeddedDriver.GetDescription: AnsiString;
begin
  Result := 'Native driver for Firebird Embedded 1.5.3';
end;

procedure TFirebird15EmbeddedDriver.Initialize;
begin
  PDOLibraryFirebird15.LibraryLoader.LoadIfNeeded;
end;


{Standard Driver}

function TFirebird15Driver.GetProtocol: AnsiString;
begin
  Result := 'firebird-1.5';
end;

function TFirebird15Driver.GetDescription: AnsiString;
begin
  Result := 'Native driver for Firebird 1.5.3';
end;

procedure TFirebird15Driver.Initialize;
begin
  PDOLibraryFirebird15.LibraryLoader.LoadIfNeeded;
end;


function TFirebird15Driver.isc_array_gen_sdl(status_vector: PISC_STATUS;
  isc_array_desc: PISC_ARRAY_DESC; isc_arg3: PShort;
  isc_arg4: PChar; isc_arg5: PShort): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_array_gen_sdl(status_vector, isc_array_desc,
    isc_arg3, isc_arg4, isc_arg5);
end;

function TFirebird15Driver.isc_array_get_slice(status_vector: PISC_STATUS;
  db_handle: PISC_DB_HANDLE; trans_handle: PISC_TR_HANDLE; array_id: PISC_QUAD;
  descriptor: PISC_ARRAY_DESC; dest_array: PVoid;
  slice_length: ISC_LONG): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_array_get_slice(status_vector, db_handle,
    trans_handle, array_id, descriptor, dest_array, slice_length);
end;

function TFirebird15Driver.isc_array_lookup_bounds(
  status_vector: PISC_STATUS; db_handle: PISC_DB_HANDLE;
  trans_handle: PISC_TR_HANDLE; table_name, column_name: PChar;
  descriptor: PISC_ARRAY_DESC): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_array_lookup_bounds(status_vector, db_handle,
    trans_handle, table_name, column_name, descriptor);
end;

function TFirebird15Driver.isc_array_lookup_desc(
  status_vector: PISC_STATUS; db_handle: PISC_DB_HANDLE;
  trans_handle: PISC_TR_HANDLE; table_name, column_name: PChar;
  descriptor: PISC_ARRAY_DESC): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_array_lookup_desc(status_vector, db_handle,
    trans_handle, table_name, column_name, descriptor);
end;

function TFirebird15Driver.isc_array_put_slice(status_vector: PISC_STATUS;
  db_handle: PISC_DB_HANDLE; trans_handle: PISC_TR_HANDLE; array_id: PISC_QUAD;
  descriptor: PISC_ARRAY_DESC; source_array: PVoid;
  slice_length: PISC_LONG): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_array_put_slice(status_vector, db_handle,
    trans_handle, array_id, descriptor, source_array, slice_length);
end;

function TFirebird15Driver.isc_array_set_desc(status_vector: PISC_STATUS;
  table_name, column_name: PChar; sql_dtype, sql_length, sql_dimensions: PShort;
  descriptor: PISC_ARRAY_DESC): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_array_set_desc(status_vector, table_name,
    column_name, sql_dtype, sql_length, sql_dimensions, descriptor);
end;

function TFirebird15Driver.isc_attach_database(status_vector: PISC_STATUS;
  db_name_length: Short; db_name: PChar; db_handle: PISC_DB_HANDLE;
  parm_buffer_length: Short; parm_buffer: PChar): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_attach_database(status_vector, db_name_length,
    db_name, db_handle, parm_buffer_length, parm_buffer);
end;

function TFirebird15Driver.isc_blob_info(status_vector: PISC_STATUS;
  blob_handle: PISC_BLOB_HANDLE; item_list_buffer_length: Short;
  item_list_buffer: PChar; result_buffer_length: Short;
  result_buffer: PChar): PISC_STATUS;
begin
  Result := PISC_STATUS(PDOLibraryFirebird15.isc_blob_info(status_vector, blob_handle,
    item_list_buffer_length, item_list_buffer, result_buffer_length,
    result_buffer));
end;

function TFirebird15Driver.isc_cancel_blob(status_vector: PISC_STATUS;
  blob_handle: PISC_BLOB_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_cancel_blob(status_vector, blob_handle);
end;

function TFirebird15Driver.isc_cancel_events(status_vector: PISC_STATUS;
  db_handle: PISC_DB_HANDLE; event_id: PISC_LONG): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_cancel_events(status_vector, db_handle,
    event_id);
end;

function TFirebird15Driver.isc_close_blob(status_vector: PISC_STATUS;
  blob_handle: PISC_BLOB_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_close_blob(status_vector, blob_handle);
end;

function TFirebird15Driver.isc_commit_retaining(
  status_vector: PISC_STATUS; tran_handle: PISC_TR_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_commit_retaining(status_vector, tran_handle);
end;

function TFirebird15Driver.isc_commit_transaction(
  status_vector: PISC_STATUS; tran_handle: PISC_TR_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_commit_transaction(status_vector, tran_handle);
end;

function TFirebird15Driver.isc_create_blob2(status_vector: PISC_STATUS;
  db_handle: PISC_DB_HANDLE; tran_handle: PISC_TR_HANDLE;
  blob_handle: PISC_BLOB_HANDLE; blob_id: PISC_QUAD; bpb_length: Short;
  bpb_address: PChar): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_create_blob2(status_vector, db_handle,
    tran_handle, blob_handle, blob_id, bpb_length, bpb_address);
end;

function TFirebird15Driver.isc_database_info(status_vector: PISC_STATUS;
  db_handle: PISC_DB_HANDLE; item_list_buffer_length: Short;
  item_list_buffer: PChar; result_buffer_length: Short;
  result_buffer: PChar): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_database_info(status_vector, db_handle,
    item_list_buffer_length, item_list_buffer, result_buffer_length,
    result_buffer);
end;

procedure TFirebird15Driver.isc_decode_date(ib_date: PISC_QUAD;
  tm_date: PCTimeStructure);
begin
  PDOLibraryFirebird15.isc_decode_date(ib_date, tm_date);
end;

procedure TFirebird15Driver.isc_decode_sql_date(ib_date: PISC_DATE;
  tm_date: PCTimeStructure);
begin
  PDOLibraryFirebird15.isc_decode_sql_date(ib_date, tm_date);
end;

procedure TFirebird15Driver.isc_decode_sql_time(ib_time: PISC_TIME;
  tm_date: PCTimeStructure);
begin
  PDOLibraryFirebird15.isc_decode_sql_time(ib_time, tm_date);
end;

procedure TFirebird15Driver.isc_decode_timestamp(
  ib_timestamp: PISC_TIMESTAMP; tm_date: PCTimeStructure);
begin
  PDOLibraryFirebird15.isc_decode_timestamp(ib_timestamp, tm_date);
end;

function TFirebird15Driver.isc_detach_database(status_vector: PISC_STATUS;
  db_handle: PISC_DB_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_detach_database(status_vector, db_handle);
end;

function TFirebird15Driver.isc_drop_database(status_vector: PISC_STATUS;
  db_handle: PISC_DB_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_drop_database(status_vector, db_handle);
end;

function TFirebird15Driver.isc_dsql_alloc_statement2(
  status_vector: PISC_STATUS; db_handle: PISC_DB_HANDLE;
  stmt_handle: PISC_STMT_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_alloc_statement2(status_vector,
    db_handle, stmt_handle);
end;

function TFirebird15Driver.isc_dsql_allocate_statement(
  status_vector: PISC_STATUS; db_handle: PISC_DB_HANDLE;
  stmt_handle: PISC_STMT_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_allocate_statement(status_vector,
    db_handle, stmt_handle);
end;

function TFirebird15Driver.isc_dsql_describe(status_vector: PISC_STATUS;
  stmt_handle: PISC_STMT_HANDLE; dialect: Word; xsqlda: PXSQLDA): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_describe(status_vector, stmt_handle,
    dialect, xsqlda);
end;

function TFirebird15Driver.isc_dsql_describe_bind(
  status_vector: PISC_STATUS; stmt_handle: PISC_STMT_HANDLE; dialect: Word;
  xsqlda: PXSQLDA): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_describe_bind(status_vector, stmt_handle,
    dialect, xsqlda);
end;

function TFirebird15Driver.isc_dsql_execute(status_vector: PISC_STATUS;
  tran_handle: PISC_TR_HANDLE; stmt_handle: PISC_STMT_HANDLE; dialect: Word;
  xsqlda: PXSQLDA): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_execute(status_vector, tran_handle,
    stmt_handle, dialect, xsqlda);
end;

function TFirebird15Driver.isc_dsql_execute_immediate(
  status_vector: PISC_STATUS; db_handle: PISC_DB_HANDLE;
  tran_handle: PISC_TR_HANDLE; length: Word; statement: PChar;
  dialect: Word; xsqlda: PXSQLDA): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_execute_immediate(status_vector,
    db_handle, tran_handle, length, statement, dialect, xsqlda);
end;

function TFirebird15Driver.isc_dsql_execute2(status_vector: PISC_STATUS;
  tran_handle: PISC_TR_HANDLE; stmt_handle: PISC_STMT_HANDLE;
  dialect: Word; in_xsqlda, out_xsqlda: PXSQLDA): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_execute2(status_vector, tran_handle,
    stmt_handle, dialect, in_xsqlda, out_xsqlda);
end;

function TFirebird15Driver.isc_dsql_fetch(status_vector: PISC_STATUS;
  stmt_handle: PISC_STMT_HANDLE; dialect: Word;
  xsqlda: PXSQLDA): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_fetch(status_vector, stmt_handle, dialect,
    xsqlda);
end;

function TFirebird15Driver.isc_dsql_free_statement(
  status_vector: PISC_STATUS; stmt_handle: PISC_STMT_HANDLE;
  options: Word): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_free_statement(status_vector, stmt_handle,
    options);
end;

function TFirebird15Driver.isc_dsql_prepare(
  status_vector: PISC_STATUS; tran_handle: PISC_TR_HANDLE;
  stmt_handle: PISC_STMT_HANDLE; length: Word; statement: PChar;
  dialect: Word; xsqlda: PXSQLDA): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_prepare(status_vector, tran_handle,
    stmt_handle, length, statement, dialect, xsqlda);
end;

function TFirebird15Driver.isc_dsql_set_cursor_name(
  status_vector: PISC_STATUS; stmt_handle: PISC_STMT_HANDLE;
  cursor_name: PChar; _type: Word): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_set_cursor_name(status_vector,
    stmt_handle, cursor_name, _type);
end;

function TFirebird15Driver.isc_dsql_sql_info(
  status_vector: PISC_STATUS; stmt_handle: PISC_STMT_HANDLE;
  item_length: Short; items: PChar; buffer_length: Short;
  buffer: PChar): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_dsql_sql_info(status_vector, stmt_handle,
    item_length, items, buffer_length, buffer);
end;

procedure TFirebird15Driver.isc_encode_date(tm_date: PCTimeStructure;
  ib_date: PISC_QUAD);
begin
  PDOLibraryFirebird15.isc_encode_date(tm_date, ib_date);
end;

procedure TFirebird15Driver.isc_encode_sql_date(
  tm_date: PCTimeStructure; ib_date: PISC_DATE);
begin
  PDOLibraryFirebird15.isc_encode_sql_date(tm_date, ib_date);
end;

procedure TFirebird15Driver.isc_encode_sql_time(
  tm_date: PCTimeStructure; ib_time: PISC_TIME);
begin
  PDOLibraryFirebird15.isc_encode_sql_time(tm_date, ib_time);
end;

procedure TFirebird15Driver.isc_encode_timestamp(
  tm_date: PCTimeStructure; ib_timestamp: PISC_TIMESTAMP);
begin
  PDOLibraryFirebird15.isc_encode_timestamp(tm_date, ib_timestamp);
end;

function TFirebird15Driver.isc_event_block(event_buffer,
  result_buffer: PPChar; id_count: Word;
  event_list: array of PChar): ISC_LONG;
begin
  Result := PDOLibraryFirebird15.isc_event_block(event_buffer, result_buffer,
    id_count, event_list);
end;

procedure TFirebird15Driver.isc_event_counts(
  status_vector: PISC_STATUS; buffer_length: Short; event_buffer,
  result_buffer: PChar);
begin
  PDOLibraryFirebird15.isc_event_counts(status_vector, buffer_length,
    event_buffer, result_buffer);
end;

function TFirebird15Driver.isc_free(isc_arg1: PChar): ISC_LONG;
begin
  Result := PDOLibraryFirebird15.isc_free(isc_arg1);
end;

function TFirebird15Driver.isc_get_segment(
  status_vector: PISC_STATUS; blob_handle: PISC_BLOB_HANDLE;
  actual_seg_length: PWord; seg_buffer_length: Word;
  seg_buffer: PChar): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_get_segment(status_vector, blob_handle,
    actual_seg_length, seg_buffer_length, seg_buffer);
end;

function TFirebird15Driver.isc_interprete(buffer: PChar;
  status_vector: PPISC_STATUS): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_interprete(buffer, status_vector);
end;

function TFirebird15Driver.isc_open_blob2(status_vector: PISC_STATUS;
  db_handle: PISC_DB_HANDLE; tran_handle: PISC_TR_HANDLE;
  blob_handle: PISC_BLOB_HANDLE; blob_id: PISC_QUAD; bpb_length: Short;
  bpb_buffer: PChar): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_open_blob2(status_vector, db_handle,
    tran_handle, blob_handle, blob_id, bpb_length, bpb_buffer);
end;

function TFirebird15Driver.isc_put_segment(
  status_vector: PISC_STATUS; blob_handle: PISC_BLOB_HANDLE;
  seg_buffer_len: Word; seg_buffer: PChar): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_put_segment(status_vector, blob_handle,
    seg_buffer_len, seg_buffer);
end;

function TFirebird15Driver.isc_que_events(status_vector: PISC_STATUS;
  db_handle: PISC_DB_HANDLE; event_id: PISC_LONG; length: Short;
  event_buffer: PChar; event_function: TISC_CALLBACK;
  event_function_arg: PVoid): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_que_events(status_vector, db_handle,
    event_id, length, event_buffer, event_function, event_function_arg)
end;

function TFirebird15Driver.isc_rollback_retaining(
  status_vector: PISC_STATUS; tran_handle: PISC_TR_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_rollback_retaining(status_vector, tran_handle);
end;

procedure TFirebird15Driver.isc_sql_interprete(sqlcode: Short;
  buffer: PChar; buffer_length: Short);
begin
  PDOLibraryFirebird15.isc_sql_interprete(sqlcode, buffer, buffer_length);
end;

function TFirebird15Driver.isc_sqlcode(
  status_vector: PISC_STATUS): ISC_LONG;
begin
  Result := PDOLibraryFirebird15.isc_sqlcode(status_vector);
end;

function TFirebird15Driver.isc_rollback_transaction(
  status_vector: PISC_STATUS; tran_handle: PISC_TR_HANDLE): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_rollback_transaction(status_vector, tran_handle);
end;

function TFirebird15Driver.isc_start_multiple(
  status_vector: PISC_STATUS; tran_handle: PISC_TR_HANDLE;
  db_handle_count: Short; teb_vector_address: PISC_TEB): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_start_multiple(status_vector, tran_handle,
    db_handle_count, teb_vector_address);
end;

function TFirebird15Driver.isc_start_transaction(
  status_vector: PISC_STATUS; tran_handle: PISC_TR_HANDLE;
  db_handle_count: Short; db_handle: PISC_DB_HANDLE; tpb_length: Word;
  tpb_address: PChar): ISC_STATUS;
begin
  Result := PDOLibraryFirebird15.isc_start_transaction(status_vector, tran_handle,
    db_handle_count, db_handle, tpb_length, tpb_address);
end;

function TFirebird15Driver.isc_vax_integer(buffer: PChar;
  length: Short): ISC_LONG;
begin
  Result := PDOLibraryFirebird15.isc_vax_integer(buffer, length);
end;



function TFirebird15Driver.GetServerVersion (Handle: TISC_DB_HANDLE): AnsiString;
begin
    Result := copy (self.Get_Information(Handle, isc_info_version), 3, maxInt);
end;

function TFirebird15Driver.Get_Information (Handle: TISC_DB_HANDLE; item: TDatabaseInformation): ansistring;
var
    Length: Integer;
    DatabaseInfoCommand: Char;
    StatusVector: TARRAY_ISC_STATUS;
    Buffer: array[0..IBBigLocalBufferLength - 1] of Char;
begin
    DatabaseInfoCommand := char(ord(item));
    self.isc_database_info(@StatusVector, @Handle, 1, @DatabaseInfoCommand, IBLocalBufferLength, Buffer);
    PDOUtilsFirebird.CheckFirebirdError(self, StatusVector);
    Length := Integer(Buffer[1]);
    Result := PDOUtilsFirebird.BufferToStr(@Buffer[3], Length);
end;

function TFirebird15Driver.GetServerInfo (Handle: TISC_DB_HANDLE): AnsiString;
var
    func_result: integer;
    user_info: TVersionPointers;
    server_info_counter: integer;
    server_info_strings: array [0..8] of array[0..159] of Char;
    info_section: ansistring;
    loop: byte;
begin
    server_info_counter := 0;
    user_info[0] := @server_info_counter;

    for loop := 0 to 8 do
    begin
        server_info_strings[loop] := '';
        user_info[loop + 1] := @server_info_strings[loop];
    end;

    func_result := PDOLibraryFirebird15.isc_version (@Handle, @version_callback, @user_info);

    info_section := server_info_strings[0];
    for loop := 1 to server_info_counter - 2 do
        info_section := info_section + ', ' + server_info_strings[loop];


    if func_result = 0 then
        Result := info_section
    else
        Result := 'Could not retrieve server information';
end;


procedure version_callback (user_arg: PVoid; information: PChar); cdecl;
var
        counter: byte;
        index: TVersionPointers;
begin
        index := TVersionPointers(user_arg^);
        counter := byte(index[0]^);

        sysUtils.StrCopy(PChar(index[counter + 1]), information);

        byte(index[0]^) := counter + 1;
end;


end.
