program example_D7_mysql50;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  dbunit in 'dbUnit.pas',
  PDO in 'PDO\PDO.pas',
  PDOClasses in 'PDO\PDOClasses.pas',
  PDOCompatibility in 'PDO\PDOCompatibility.pas',
  PDOConnection in 'PDO\PDOConnection.pas',
  PDOInterfaces in 'PDO\PDOInterfaces.pas',
  PDOLogging in 'PDO\PDOLogging.pas',
  PDOMessages in 'PDO\PDOMessages.pas',
  PDOPlainLoader in 'PDO\PDOPlainLoader.pas',
  PDOStatement in 'PDO\PDOStatement.pas',
  PDOSysUtils in 'PDO\PDOSysUtils.pas',
  PDOMySQLDriver in 'PDO\drivers\mysql\PDOMySQLDriver.pas',
  PDOLibraryMySQL40 in 'PDO\drivers\mysql\mysql_4_0\PDOLibraryMySQL40.pas',
  PDOLibraryMySQL41 in 'PDO\drivers\mysql\mysql_4_1\PDOLibraryMySQL41.pas',
  PDOLibraryMySQL50 in 'PDO\drivers\mysql\mysql_5_0\PDOLibraryMySQL50.pas',
  PDODriverMySQL40 in 'PDO\drivers\mysql\mysql_4_0\PDODriverMySQL40.pas',
  PDODriverMySQL41 in 'PDO\drivers\mysql\mysql_4_1\PDODriverMySQL41.pas',
  PDODriverMySQL50 in 'PDO\drivers\mysql\mysql_5_0\PDODriverMySQL50.pas',
  PDOConstantsMySQL in 'PDO\drivers\mysql\PDOConstantsMySQL.pas',
  PDOConnectMySQL in 'PDO\drivers\mysql\PDOConnectMySQL.pas',
  PDOUtilsMySQL in 'PDO\drivers\mysql\PDOUtilsMySQL.pas',
  PDOStatementMySQL in 'PDO\drivers\mysql\PDOStatementMySQL.pas',
  PDOResultMySQL in 'PDO\drivers\mysql\PDOResultMySQL.pas',
  PDOResult in 'PDO\PDOResult.pas',
  PDOSQL in 'PDO\PDOSQL.pas',
  PDOSQLDelete in 'PDO\PDOSQLDelete.pas',
  PDOSQLUpdate in 'PDO\PDOSQLUpdate.pas';

var
   teamNumber: Integer;
   locstr, mascotstr, abbreviation: AnsiString;

begin
    writeln('Delphi 7 - With mysql 5.0 (Prep Stmt + Binding)');
    if db.connect('pdo:mysql-5.0://host=localhost;dbname=pdo_test','pdo_user','pdo') then
    begin
        writeln ('connection succeeded');
        stmt := db.prepare_as_is ('SELECT nfl_team, abbreviation, location, name FROM nfl_teams WHERE nfl_team >= :name');
        stmt.bindValue ('name', 0);
        stmt.bindColumn (0, @teamNumber, integer_8_signed);
        stmt.bindColumn (1, @abbreviation, string_1);
        stmt.bindColumn ('location', @locstr, string_1);
        stmt.bindColumn ('name', @mascotstr, string_unlimited);
        stmt.execute;

        writeln ('Number  Abbr    NFL Location and Mascot');
        writeln ('=======================================');
        while (stmt.fetch_bound) do
        begin
                writeln(IntToStr(teamNumber) + chr(9) +
                	abbreviation + chr(9) +
                	locstr + ' ' +	mascotstr);
        end;
    end
else
    begin
        writeln ('connection attempt failed');
    end;
end.
 